<?php    
    //require_once 'model/productogrupoelectrogeno.entidad.php';
    //require_once 'model/productogrupoelectrogeno.model.php';
    // require_once 'model/producto.entidad.php';
    // require_once 'model/producto.model.php';
    require_once 'model/evaluacion.entidad.php';
    require_once 'model/evaluacion.model.php';
    require_once 'model/usuario.entidad.php';
    require_once 'model/usuario.model.php';
    require_once 'model/parametro.model.php';
    require_once 'model/parametro.entidad.php';
    require_once 'model/organigrama.model.php';
    require_once 'model/organigrama.entidad.php';
    require_once 'model/cuestionario.model.php';
    require_once 'model/cuestionario.entidad.php';
    require_once 'model/evaluaciondetalle.model.php';
    require_once 'model/evaluaciondetalle.entidad.php';
    
    
    class EvaluacionController extends helpers {
        private $producto_model;
        private $usuario_model;
        private $parametro_model;
        private $organigrama_model;
        private $evaluaciondetalle_model;
        //private $productogrupoelectrogeno_model;

        private $evaluacion_model;
        public function __CONSTRUCT(){
            $this->evaluacion_model = new EvaluacionModel();
            // $this->producto_model = new ProductoModel();
            $this->usuario_model = new UsuarioModel();
            $this->parametro_model = new ParametroModel();
            $this->organigrama_model = new OrganigramaModel();
            $this->cuestionario_model = new CuestionarioModel();
            $this->evaluaciondetalle_model = new EvaluaciondetalleModel();
            //$this->productogrupoelectrogeno_model = new ProductogrupoelectrogenoModel();

        }
        
        public function Index(){
            $parametro = $this->parametro_model->ListarParametros();
            $evaluaciones = $this->evaluacion_model->Listar();

            require_once 'view/header.php';  
            require_once 'view/webforms/wfaevaluacion.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
        }


        public function EvaluacionEvaluador(){
            $parametro = $this->parametro_model->ListarParametros();
            $producto= $this->evaluacion_model->Listar();

            require_once 'view/headercliente.php';  
            require_once 'view/webevaluador/wfaevaluacionevaluador.php';
            echo "<script type='text/javascript'>
                        $(document).ready(function (){
                            $('.operaciones').addClass('active');
                        });
                  </script>";
            require_once 'view/footer.php'; 
        }




        public function FrmGuardarProducto(){

            //regresaremos traendo los arrays
          $_SESSION['estadoEvaluacion']=0;
          if (isset($_POST["lastjsonArray"])) {
            if ($_POST["lastjsonArray"]!=null && $_POST["lastjsonArray2"]!=null && $_POST["lastjsonArrayEmp"]!=null && $_POST['lastjsonArrayTipoEvEmp']!=null ) {
              $empleadosArray= json_decode($_POST["lastjsonArrayEmp"]);
              $empleadosNombArray= json_decode($_POST["lastjsonArrayNombEmp"]);
              $empleadosTipoEvArray = json_decode($_POST["lastjsonArrayTipoEvEmp"]);
              $cuestEvaluadosArray= json_decode($_POST["lastjsonArray"]);
              $cuestEvaluadorArray= json_decode($_POST["lastjsonArray2"]);
            }
          }
            require_once 'view/webforms/wfaevaluaciona.php'; 
        }

        //traemos el formulario con la data de todos los puestos
        public function FrmGuardarProductoAll(){

            //regresaremos traendo los arrays
          $_SESSION['estadoEvaluacion']=0;
          if (isset($_POST["lastjsonArray1"])) {
            if ($_POST["lastjsonArray1"]!=null && $_POST["lastjsonArray2"]!=null && $_POST["lastjsonArray3"]!=null) {
              $cuestEvaluadosEArray= json_decode($_POST["lastjsonArray1"]);
              $cuestEvaluadosMArray= json_decode($_POST["lastjsonArray2"]);
              $cuestEvaluadosOArray= json_decode($_POST["lastjsonArray3"]);
              echo $_POST["lastjsonArray1"];echo $_POST["lastjsonArray2"];echo $_POST["lastjsonArray3"];
            }
          }
            require_once 'view/webforms/wfaevaluacionaall.php'; 
        }

        //regresando al formulario principal para editar
        public function FrmModificarProducto(){

            //regresaremos traendo los arrays
          if (isset($_POST["lastjsonArray"])) {
            if ($_POST["lastjsonArray"]!=null && $_POST["lastjsonArray2"]!=null && $_POST["lastjsonArrayEmp"]!=null) {
              $empleadosArray= json_decode($_POST["lastjsonArrayEmp"]);
              $empleadosNombArray= json_decode($_POST["lastjsonArrayNombEmp"]);
              $cuestEvaluadosArray= json_decode($_POST["lastjsonArray"]);
              $cuestEvaluadorArray= json_decode($_POST["lastjsonArray2"]);
            }
          }
            require_once 'view/webforms/wfaevaluacionac.php'; 
        }

        public function Paso1(){
            $organigrama = $this->organigrama_model->Listar();
            require_once 'view/webforms/wfaevaluaciondet1.php';
                        
        }

        public function Paso2(){
            $hijos = $this->organigrama_model->BuscarPadre($_POST['Organigrama_Id']);
            $padre = $_POST['Organigrama_Id'];
            $nombrePadre = $_POST['sOrgDescripcion'];
            $organigrama = $this->organigrama_model->Listar();
            require_once 'view/webforms/wfaevaluaciondet2.php';
                        
        }

        public function Paso3(){
            $jsonArrayEmp= $_POST['jsonArray'];
            $jsonArrayNombEmp = $_POST['jsonArrayNomb'];
            $jsonArrayTipoEv = $_POST['jsonArrayTipo'];
            //echo "PRUEBA:".$jsonArrayEmp;
            $organigrama = $this->organigrama_model->Listar();
            require_once 'view/webforms/wfaevaluaciondet3.php';
                        
        }

        //paso para obtener todos los cuestionarios y categorias automaticamente
        //para esto debemos guardar la cabecera de la evaluacion y mandar el id
        //de la evaluacion en el hidden que esta en la vista
        public function PasoAll(){
            $evaluacion = new Evaluacion();

            $evaluacion->__SET('sEvaNombre', $_POST['sEvaNombre']);
            $evaluacion->__SET('sEvaDescripcion', $_POST['sEvaDescripcion']);
            $evaluacion->__SET('dEvaInicio', $_POST['dEvaInicio']);
            $evaluacion->__SET('dEvaFin', $_POST['dEvaFin']);
            $evaluacion->__SET('nEvaEstado', $_POST['nEvaEstado']);
            $evaluacion->__SET('nEvaOculto', 0);
            $evaluacion->__SET('nEvaUsuario_Id', $_SESSION['usu_codigo']);

            $evaluacion_Id= $this->evaluacion_model->Crear($evaluacion);
            //$evaluacion_Id="test";
            $organigrama = $this->organigrama_model->Listar();
            require_once 'view/webforms/wfaevaluaciondet1All.php';
                        
        }

        //pasar a esta funcion para editar con todos los pasos en la evaluacion
        public function ModificarPasoAll(){
            $evaluacion_Id= $_POST['evaluacion_Id'];
            //$evaluacion_Id="test";
            $organigrama = $this->organigrama_model->Listar();
            require_once 'view/webforms/wfaevaluaciondet1All.php';
                        
        }

        function FrmEditarOrganigramaAll(){
            $organigrama = $this->organigrama_model->Listar();
            $datos = $this->organigrama_model->Buscar($_POST['Organigrama_Id']);

            //variable de session
            foreach ($datos as $r){                
                require 'view/webforms/wfaevaluaciondet1aAll.php';
            }
        }

        //guardaremos las evaluacion con el evadet_genera para realizar guardados automáticos
        public function GuardarDetalleEvaluacionPadrehijo(){

            if ($_POST["lastjsonArray"]!=null) {
              if (isset($_POST['lastjsonArray'])) {
                $data = json_decode($_POST['lastjsonArray']);
                for ($i = 0; $i < count($data); $i++) {
                    $evaluaciondet= new Evaluaciondetalle();
                    $evaluaciondet->__SET('nEvaDetEvaluacion_Id', $_POST['Evaluacion_Id']);
                    $evaluaciondet->__SET('Organigrama_Id', $_POST['Organigrama_Id']);
                    $evaluaciondet->__SET('OrgCat_Id', $data[$i]->OrgCat_Id);
                    $evaluaciondet->__SET('nEvaDetCuestionario_Id', $data[$i]->cuestionario_Id);
                    $evaluaciondet->__SET('nEvaDetUsuario_Id', $_SESSION['usu_codigo']);
                    $this->evaluaciondetalle_model->GuardarDetPadreHijo($evaluaciondet);
                }
              }
            }

            unset($data);
        }
        //------------------

        function FrmEditarOrganigrama2(){
            $organigrama = $this->organigrama_model->Listar();
            $datos = $this->organigrama_model->Buscar($_POST['Organigrama_Id']);
            foreach ($datos as $r){                
                require 'view/webforms/wfaevaluaciondet2a.php';
            }
        }

        //listando cuestionarios para el paso 3

        function ListarCuestionarios(){

            $cuestionario = $this->cuestionario_model->Listar();

            foreach ($cuestionario as $cuest){
                echo '<option value="'.$cuest->__GET('cuestionario_Id').'">'.$cuest->__GET('sCueCodigo').' '.$cuest->__GET('sCueNombre').  '</option>';
            }

        }


        public function GuardarEvaluacion(){

          $evaluacion = new Evaluacion();

          $evaluacion->__SET('sEvaNombre', $_POST['sEvaNombre']);
          $evaluacion->__SET('sEvaDescripcion', $_POST['sEvaDescripcion']);
          $evaluacion->__SET('dEvaInicio', $_POST['dEvaInicio']);
          $evaluacion->__SET('dEvaFin', $_POST['dEvaFin']);
          $evaluacion->__SET('nEvaEstado', $_POST['nEvaEstado']);
          $evaluacion->__SET('nEvaOculto', $_POST['nEvaOculto']);
          $evaluacion->__SET('nEvaUsuario_Id', $_POST['nEvaUsuario_Id']);
          // $evaluacion->__SET('porcAuto', $_POST['porcAuto']);
          // $evaluacion->__SET('porcJefe', $_POST['porcJefe']);
          // $evaluacion->__SET('porcSub', $_POST['porcSub']);
          // $evaluacion->__SET('porcPar', $_POST['porcPar']);

          $evaluacion_Id= $this->evaluacion_model->Crear($evaluacion);
          // echo '<pre>';
          // var_dump($_POST['jsonArrayDet']);
          // echo '</pre>';
          // exit();
          // if ($evaluacion!=null) {
          //   if (isset($_POST['jsonArrayDet'])) {
          //     $data = json_decode($_POST['jsonArrayDet']);
          //     for ($i = 0; $i < count($data); $i++) {
          //         $evaluaciondet= new Evaluaciondetalle();
          //         $evaluaciondet->__SET('nEvaDetEvaluacion_Id', $evaluacion_Id);
          //         $evaluaciondet->__SET('nEvaDetEvaluado_Id', $data[$i]->nEvaDetEvaluado_Id);
          //         $evaluaciondet->__SET('nEvaDetEvaluador_Id', $data[$i]->nEvaDetEvaluador_Id);
          //         $evaluaciondet->__SET('nEvaDetTipo', $data[$i]->nEvaDetTipo);
          //         $evaluaciondet->__SET('nEvaDetCuestionario_Id', $data[$i]->nEvaDetCuestionario_Id);
          //         $evaluaciondet->__SET('nEvaDetEstado', 1);
          //         $evaluaciondet->__SET('nEvaDetAvance', 0);
          //         $evaluaciondet->__SET('nEvaDetUsuario_Id', 1);
          //         $evaluaciondetalles= $this->evaluaciondetalle_model->GuardarDet($evaluaciondet);
          //     }
          //   }
          // }

          unset($data);
          echo '<div class="alert alert-success alert-dismissable">
                                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                                    <h4>  <i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                                    Se guardo correctamente.
                                  </div>';


        }

        //modificando la evaluacion en un diferente metodo

        public function ModificarEvaluacion(){
          $evaluacion = new Evaluacion();

          $evaluacion->__SET('evaluacion_Id', $_POST['evaluacion_Id']);
          $evaluacion->__SET('sEvaNombre', $_POST['sEvaNombre']);
          $evaluacion->__SET('sEvaDescripcion', $_POST['sEvaDescripcion']);
          $evaluacion->__SET('dEvaInicio', $_POST['dEvaInicio']);
          $evaluacion->__SET('dEvaFin', $_POST['dEvaFin']);
          $evaluacion->__SET('nEvaEstado', $_POST['nEvaEstado']);
          $evaluacion->__SET('nEvaOculto', $_POST['nEvaOculto']);
          $evaluacion->__SET('nEvaUsuario_Id', $_POST['nEvaUsuario_Id']);
          // $evaluacion->__SET('porcAuto', $_POST['porcAuto']);
          // $evaluacion->__SET('porcJefe', $_POST['porcJefe']);
          // $evaluacion->__SET('porcSub', $_POST['porcSub']);
          // $evaluacion->__SET('porcPar', $_POST['porcPar']);

          $this->evaluacion_model->Editar($evaluacion);

          if ($evaluacion!=null) {
            if (isset($_POST['jsonArrayDet'])) {
              $data = json_decode($_POST['jsonArrayDet']);
              
              for ($i = 0; $i < count($data); $i++) {
                  $evaluaciondet= new Evaluaciondetalle();
                  $evaluaciondet->__SET('nEvaDetEvaluacion_Id', $_POST['evaluacion_Id']);
                  $evaluaciondet->__SET('nEvaDetEvaluado_Id', $data[$i]->nEvaDetEvaluado_Id);
                  $evaluaciondet->__SET('nEvaDetEvaluador_Id', $data[$i]->nEvaDetEvaluador_Id);
                  $evaluaciondet->__SET('nEvaDetTipo', $data[$i]->nEvaDetTipo);
                  $evaluaciondet->__SET('nEvaDetCuestionario_Id', $data[$i]->nEvaDetCuestionario_Id);
                  $evaluaciondet->__SET('nEvaDetEstado', 1);
                  $evaluaciondet->__SET('nEvaDetAvance', 0);
                  $evaluaciondet->__SET('nEvaDetUsuario_Id', 1);
                  $evaluaciondetalles= $this->evaluaciondetalle_model->GuardarDet($evaluaciondet);
              }
            }
          }

          unset($data);
          echo '<div class="alert alert-success alert-dismissable">
                                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                                    <h4>  <i class="icon fa fa-check"></i> Informacion Modificada.</h4>
                                    Se guardo correctamente.
                                  </div>';
        }
        
        //enviando a la edición
        public function FrmEditarEvaluacion(){
            $_SESSION['estadoEvaluacion']=$_POST['evaluacion_Id'];
            $datos = $this->evaluacion_model->Buscar($_POST['evaluacion_Id']);
            $datosdet = $this->evaluaciondetalle_model->Buscar($_POST['evaluacion_Id']);
            //estableciendo un estado para capturar toda la data
            $tipoGuardado=0;
            //json_encode($datosdet);

            if (isset($_POST["lastjsonArray"])) {
              if ($_POST["lastjsonArray"]!=null && $_POST["lastjsonArray2"]!=null && $_POST["lastjsonArrayEmp"]!=null && $_POST['lastjsonArrayTipoEvEmp']!=null) {
                $empleadosArray= json_decode($_POST["lastjsonArrayEmp"]);
                $empleadosNombArray= json_decode($_POST["lastjsonArrayNombEmp"]);
                $empleadosTipoEvArray = json_decode($_POST["lastjsonArrayTipoEvEmp"]);
                $cuestEvaluadosArray= json_decode($_POST["lastjsonArray"]);
                $cuestEvaluadorArray= json_decode($_POST["lastjsonArray2"]);
                $tipoGuardado=1;
              }
            }
            foreach ($datos as $r):
                require_once 'view/webforms/wfaevaluacionac.php';            
            endforeach;       
        }

        //eliminando defrente en la base de datos aquellos que se traen de la bd
        public function eliminarDBEvaDet(){
          $evaldet= new Evaluaciondetalle();
          $evaldet->__SET('evaluaciondetalle_Id', $_POST['evaluaciondetalle_Id']);
          $this->evaluaciondetalle_model->Eliminar($evaldet);
        }

        public function EliminarEvaluacion() {
            $evaluacion = new Evaluacion();
            $evaluacion->__SET('evaluacion_Id', $_POST['idEvaluacion']);
            $evaluacion->__SET('nEvaUsuario_Id', $_SESSION['usu_codigo']);
            $this->evaluacion_model->Eliminar($evaluacion);
            echo '<script type="text/javascript">window.location="?c=Evaluacion&a=Index";</script>';  
        }

        public function getProducto($Producto_Id){
            
            $datos= $this->producto_model->Buscar($Producto_Id);
            $html = "";
            foreach ($datos as $r):
                $html .= " <tbody>
                          <tr>
                             <td>
                                <input type='hidden' name='idProducto_Print' id='idProducto_Print' value='".$r->__GET('producto_id')."'> 
                                Descripcion
                             </td>
                             <td>".$r->__GET('sproDescripcion')."</td>
                          </tr>
                          <tr>
                             <td>Marca</td>
                             <td>".$r->__GET('sTPrMarca')."</td>
                          </tr>  
                          <tr>
                             <td>Modelo</td>
                             <td>".$r->__GET('sTPrModelo')."</td>
                          </tr>  
                          <tr>
                             <td>Modelo Motor</td>
                             <td>".$r->__GET('sTPrModeloMotor')."</td>
                          </tr>  
                          <tr>
                             <td>Potencia</td>
                             <td>".$r->__GET('sTPrPotencia')."</td>
                          </tr>  
                          <tr>
                             <td>Alternador</td>
                             <td>".$r->__GET('sTPrAlternador')."</td>
                          </tr>   
                          <tr>
                             <td>Gobernacion</td>
                             <td>".$r->__GET('sTPrTipoGobernacion')."</td>
                          </tr>   
                          <tr>
                             <td>Aspiracion</td>
                             <td>".$r->__GET('sTPrTipoAspiracion')."</td>
                          </tr>  
                          <tr>
                             <td>Prime KVA</td>
                             <td>".$r->__GET('nTPrPrimeKVA')."</td>
                          </tr>  
                          <tr>
                             <td>Stand by KVA</td>
                             <td>".$r->__GET('nTPrStandByKVA')."</td>
                          </tr>  
                       </tbody>
                     ";
            endforeach;
            return $html;
        }
        public function MostrarProducto(){
            echo $this->getProducto($_POST['Producto_Id']);
        }
        public function GuardarProducto(){  
            $not = new Producto();
            if($_POST['producto_id'] != 0 ? $not->__SET('producto_id', $_POST['producto_id']) : '');
            $not->__SET('sproDescripcion', $_POST['sproDescripcion']);

            if($_POST['producto_id'] != 0) {

              $this->producto_model->Editar($not);

               $pro = new Productogrupoelectrogeno();

               $pro->__SET('Producto_Id', $this->str_uppercase($_POST['producto_id']));
               $pro->__SET('Productogrupoelectrogeno_Id', $this->str_uppercase($_POST['Productogrupoelectrogeno_Id']));
               $pro->__SET('sTPrMarca', $this->str_uppercase($_POST['sTPrMarca']));
               $pro->__SET('sTPrModelo', $this->str_uppercase($_POST['sTPrModelo']));
               $pro->__SET('sTPrModeloMotor', $this->str_uppercase($_POST['sTPrModeloMotor']));
               $pro->__SET('sTPrPotencia', $this->str_uppercase($_POST['sTPrPotencia']));
               $pro->__SET('sTPrAlternador', $this->str_uppercase($_POST['sTPrAlternador']));
               $pro->__SET('sTPrTipoGobernacion', $this->str_uppercase($_POST['sTPrTipoGobernacion']));
               $pro->__SET('sTPrTipoAspiracion', $this->str_uppercase($_POST['sTPrTipoAspiracion']));
               $pro->__SET('nTPrPrimeKVA', $this->str_uppercase($_POST['nTPrPrimeKVA']));
               $pro->__SET('nTPrStandByKVA', $this->str_uppercase($_POST['nTPrStandByKVA']));
               $pro->__SET('nTPrUsuario_Id', $_SESSION['usu_codigo']);

               $this->productogrupoelectrogeno_model->Editar($pro);
               
               echo '<div class="alert alert-success alert-dismissable">
                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                    <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                    Se modifico correctamente.
                  </div>';
               
                echo '<script type="text/javascript">window.location="?c=Producto&a=Index";</script>';
            } else { 
            
              $producto_id = $this->producto_model->Crear($not); 
              $pro = new Productogrupoelectrogeno();
              
               $pro->__SET('Producto_Id', $producto_id);
               $pro->__SET('sTPrMarca', $this->str_uppercase($_POST['sTPrMarca']));
               $pro->__SET('sTPrModelo', $this->str_uppercase($_POST['sTPrModelo']));
               $pro->__SET('sTPrModeloMotor', $this->str_uppercase($_POST['sTPrModeloMotor']));
               $pro->__SET('sTPrPotencia', $this->str_uppercase($_POST['sTPrPotencia']));
               $pro->__SET('sTPrAlternador', $this->str_uppercase($_POST['sTPrAlternador']));
               $pro->__SET('sTPrTipoGobernacion', $this->str_uppercase($_POST['sTPrTipoGobernacion']));
               $pro->__SET('sTPrTipoAspiracion', $this->str_uppercase($_POST['sTPrTipoAspiracion']));
               $pro->__SET('nTPrPrimeKVA', $this->str_uppercase($_POST['nTPrPrimeKVA']));
               $pro->__SET('nTPrStandByKVA', $this->str_uppercase($_POST['nTPrStandByKVA']));
               $pro->__SET('nTPrUsuario_Id', $_SESSION['usu_codigo']);

               $this->productogrupoelectrogeno_model->Crear($pro);
               
               echo '<div class="alert alert-success alert-dismissable">
                                    <button type="button" class="close" data-dismiss="alert" aria-hidden="true">×</button>
                                    <h4>	<i class="icon fa fa-check"></i> Informacion Guardada.</h4>
                                    Se guardo correctamente.
                                  </div>';
            
            }
        }
        
        public function EliminarProducto(){
            $not = new Producto();
            $not->__SET('producto_id', $_POST['idProducto']);
            $this->producto_model->Eliminar($not);
            echo '<script type="text/javascript">window.location="?c=Producto&a=Index";</script>';            
        }
        
        public function PDFProducto(){            
            require_once 'view/webforms/PDF/producto.php';
        }
        
        public function Search(){
            print_r(json_encode($this->producto_model->Buscar($_POST['producto_id']), JSON_PRETTY_PRINT));            
        }

        public function AplicarCuestionario(){            
            require_once 'view/webforms/wfaclicuestionarioaplicar.php';
        }

        public function AnunciarEvaluacion(){
          $evaluacion_Id = $_POST['evaluacion_Id'];
          $evaluaciones = $this->evaluacion_model->ObtenerEvaluados($evaluacion_Id);

          ini_set('max_execution_time', 600); // 600 segundos = 10 minutos
          ini_set('memory_limit', '1024M'); // 

          $batchSize = 20; // Tamaño del lote
          $totalEmails = count($evaluaciones);
          $batchCount = ceil($totalEmails / $batchSize);
          $errorLog = '';

          for ($batch = 0; $batch < $batchCount; $batch++) {
              $start = $batch * $batchSize;
              $end = min(($batch + 1) * $batchSize, $totalEmails);

              for ($i = $start; $i < $end; $i++) {
                  $eva = $evaluaciones[$i];
                  $personal_Id = $eva->__GET("personal_Id");
                  $Evaluador = $eva->__GET("Evaluador");
                  $Correo = $eva->__GET("Correo");
                  $Clave = $eva->__GET("Clave");
                  $Puesto = $eva->__GET("Puesto");
                  $Evaluacion = $eva->__GET("Evaluacion");
                  $Inicio = date("d-m-Y", strtotime($eva->__GET("Inicio")));
                  $Fin = date("d-m-Y", strtotime($eva->__GET("Fin")));

                  $asunto = "Descubriendo tu poder interior";

                  $mensaje = '<html>
                                  <head>
                                      <title>Mensaje de Confirmacion</title>
                                      <style type="text/css">
                                          table{
                                              text-align: center;
                                              width: 100%;
                                              padding: 0px;
                                              border: 1px solid #ccc;
                                              margin-bottom: 50px;
                                          }
                                          table tr th,
                                          table tr td{
                                              padding: 10px;
                                              border: 1px solid #ccc;
                                              color: #494949;
                                          }
                                          table tr th{
                                              background: #D80000;
                                              font-weight: bold;
                                              color: #fff;
                                          }
                                          .content{
                                              padding: 10px;
                                          }
                                          .text {
                                            color: #000;
                                          }
                                      </style>    
                                  </head>
                                  <body>
                                      <div class="content">
                                          <H4 style="color: #D80000;font-weight: bold;">Estimado(a) '.$Evaluador.'</H4>

                                          <p class="text">Gracias por su participación en el proceso de evaluación que se inicia el día miécoles 03/06 hasta el martes 20/06. Les recordamos tomarse el tiempo necesario evitando interrupciones  para realizar una evaluación responsable que sirva de herramienta para el objetivo planteado.</p><p class="text">A continuación el link</p><p><a href="https://fmsac.com/ruttamartina" target="_blank">https://fmsac.com/ruttamartina</a></p><p class="text">Usuario:</p><p class="text"><b>'.$Correo.'</b></p><p class="text">Contraseña:</p><p class="text"><b>'.$Clave.'</b></p><p class="text">Gracias y saludos</p>
                                          <img src="view/librerias/dist/img/logo_mb.jpg">
                                      </div>
                                  </body>
                              </html>';

                  try {
                      $this->evaluacion_model->AnunciarEvaluacion($Evaluador, $asunto, $Correo, $mensaje);
                  } catch (Exception $e) {
                      $errorLog .= "Error enviando a $Correo: " . $e->getMessage() . "\n";
                  }
              }

              // evitar problemas con el servidor SMTP
              sleep(10);
          }

          if (!empty($errorLog)) {
              // Guardar los errores en un archivo de log
              file_put_contents('error_log.txt', $errorLog);
          }

          echo '<script type="text/javascript">window.location="?c=Evaluacion&a=Index";</script>';


          // foreach ($evaluaciones as $eva) {
          //   $personal_Id = $eva->__GET("personal_Id");
          //   $Evaluador = $eva->__GET("Evaluador");
          //   $Correo = $eva->__GET("Correo");
          //   $Clave = $eva->__GET("Clave");
          //   $Puesto = $eva->__GET("Puesto");
          //   $Evaluacion = $eva->__GET("Evaluacion");
          //   $Inicio = date("d-m-Y", strtotime($eva->__GET("Inicio")));
          //   $Fin = date("d-m-Y", strtotime($eva->__GET("Fin")));

          //   $asunto = "Descubriendo tu poder interior";

          //   $mensaje = '<html>
          //                       <head>
          //                           <title>Mensaje de Confirmacion</title>
          //                           <style type="text/css">
          //                               table{
          //                                   text-align: center;
          //                                   width: 100%;
          //                                   padding: 0px;
          //                                   border: 1px solid #ccc;
          //                                   margin-bottom: 50px;
          //                               }
          //                               table tr th,
          //                               table tr td{
          //                                   padding: 10px;
          //                                   border: 1px solid #ccc;
          //                                   color: #494949;
          //                               }
          //                               table tr th{
          //                                   background: #D80000;
          //                                   font-weight: bold;
          //                                   color: #fff;
          //                               }
          //                               .content{
          //                                   padding: 10px;
          //                               }
          //                               .text {
          //                                 color: #000;
          //                               }
          //                           </style>    
          //                       </head>
          //                       <body>
          //                           <div class="content">
          //                               <H4 style="color: #D80000;font-weight: bold;">Estimado(a) '.$Evaluador.'</H4>

          //                               <p class="text">Gracias por su participación en el proceso de evaluación que se inicia el día miécoles 03/06 hasta el martes 20/06. Les recordamos tomarse el tiempo necesario evitando interrupciones  para realizar una evaluación responsable que sirva de herramienta para el objetivo planteado.</p><p class="text">A continuación el link</p><p><a href="https://fmsac.com/ruttamartina" target="_blank">https://fmsac.com/ruttamartina</a></p><p class="text">Usuario:</p><p class="text"><b>'.$Correo.'</b></p><p class="text">Contraseña:</p><p class="text"><b>'.$Clave.'</b></p><p class="text">Gracias y saludos</p>
          //                               <img src="view/librerias/dist/img/logo_mb.jpg">
          //                           </div>
          //                       </body>
          //                   </html>
          //                   ';

          //   $this->evaluacion_model->AnunciarEvaluacion($Evaluador, $asunto, $Correo, $mensaje);

          //   echo '<script type="text/javascript">window.location="?c=Evaluacion&a=Index";</script>';

          // }
        }
    }
?>