select * from personal;

DROP PROCEDURE IF EXISTS `cue_eliminar`;

DELIMITER $$
CREATE DEFINER=`root`@`localhost` PROCEDURE `cue_eliminar`(IN `pcuestionario_id` INT(11))
BEGIN
   DELETE FROM `cuestionario`
       WHERE cuestionario_Id = pcuestionario_id;

END $$
DELIMITER ;



USE `15mbgh`;
DROP procedure IF EXISTS `res_listar`;

USE `15mbgh`;
DROP procedure IF EXISTS `15mbgh`.`res_listar`;
;

DELIMITER $$
USE `15mbgh`$$
CREATE DEFINER=`root`@`localhost` PROCEDURE `res_listar`(IN `pEvaluador_Id` INT(11))
BEGIN

   SELECT

	ed.evaluaciondetalle_Id,

	p.personal_Id,
    
    ed.nEvaDetTipo,
    
    c.cuestionario_Id,

	CONCAT(p.sPerApePaterno,' ', p.sPerApeMaterno, ', ', p.sPerNombres) as Personal,

	sEvaNombre as Evaluacion,

	o.sOrgDescripcion as Puesto,

	c.sCueCodigo,

	0 as 'nResEstado',
    
    0 as 'resultado_Id'

	FROM evaluacion e

	inner join evaluaciondetalle ed on (ed.nEvaDetEvaluacion_Id=e.evaluacion_Id)
	inner join personal p on (p.sPerCargo=ed.nEvaDetEvaluado_Id)
	inner join personal evaluador on (evaluador.sPerCargo=ed.nEvaDetEvaluador_Id)
	inner join organigrama o on (o.organigrama_Id=p.sPerCargo)
	inner join cuestionario c on (c.cuestionario_Id = ed.nEvaDetCuestionario_Id)
	where evaluador.Personal_Id=pEvaluador_Id

	and p.personal_Id not in (

		SELECT

		p.personal_Id

		FROM evaluacion e

		inner join evaluaciondetalle ed on (ed.nEvaDetEvaluacion_Id=e.evaluacion_Id)

		inner join resultado r on (r.nResEvaluacionDetalle_Id=ed.EvaluacionDetalle_Id)

		inner join personal p on (p.personal_Id=r.nResEvaluado_Id)

		where r.nResEvaluador_Id=pEvaluador_Id

	)

	UNION

	SELECT

	ed.evaluaciondetalle_Id,

	p.personal_Id,
    
    ed.nEvaDetTipo,
    
    c.cuestionario_Id,

	CONCAT(sPerApePaterno,' ', sPerApeMaterno, ', ', sPerNombres) as Personal,

	sEvaNombre as Evaluacion,

	o.sOrgDescripcion as Puesto,

	c.sCueCodigo,

	nResEstado,
    
    r.resultado_Id

	FROM evaluacion e

	inner join evaluaciondetalle ed on (ed.nEvaDetEvaluacion_Id=e.evaluacion_Id)

	inner join cuestionario c on (c.cuestionario_Id = ed.nEvaDetCuestionario_Id)

	inner join resultado r on (r.nResEvaluacionDetalle_Id=ed.EvaluacionDetalle_Id)

	inner join personal p on (p.personal_Id=r.nResEvaluado_Id)

	inner join organigrama o on (o.organigrama_Id=p.sPerCargo)

	where r.nResEvaluador_Id=pEvaluador_Id


	order by Puesto, Personal;

END$$

DELIMITER ;
;

