<?php

require_once(__DIR__ . '/../view/librerias/PHPExcel2/Classes/PHPExcel.php');
require_once(__DIR__ . '/../view/librerias/PHPExcel2/Classes/PHPExcel/IOFactory.php');
// require_once '/../view/librerias/PHPExcel2/Classes/PHPExcel.php';
// require_once '/../view/librerias/PHPExcel2/Classes/PHPExcel/IOFactory.php';

$objPHPExcel = new PHPExcel();
$objPHPExcel->setActiveSheetIndex(0)
            ->setCellValue('A1', 'Evaluado')
            ->setCellValue('B1', 'Puntaje')
            ->setCellValue('C1', 'Tipo de Evaluacion')
            ->setCellValue('D1', 'Puesto')
            ->setCellValue('E1', 'Area')
            ->setCellValue('F1', 'Grupo')
            ->setCellValue('G1', 'Planilla')
            ->setCellValue('H1', 'Centro');
$sheet = $objPHPExcel->getActiveSheet();
$rowIndex = 2;

foreach ($reporte as $item) {
$sheet->setCellValue('A'.$rowIndex, $item->Evaluado);
$sheet->setCellValue('B'.$rowIndex, $item->Puntaje);
$sheet->setCellValue('C'.$rowIndex, $item->TipoEvaluacion);
$sheet->setCellValue('D'.$rowIndex, $item->Puesto);
$sheet->setCellValue('E'.$rowIndex, $item->sPerArea);
$sheet->setCellValue('F'.$rowIndex, $item->sPerGrupo);
$sheet->setCellValue('G'.$rowIndex, $item->sPerPlanilla);
$sheet->setCellValue('H'.$rowIndex, $item->sPerCentro);

$rowIndex++;
}

foreach (range('A', 'H') as $column) {
$objPHPExcel->getActiveSheet()->getColumnDimension($column)->setAutoSize(true);
}

$objWriter = PHPExcel_IOFactory::createWriter($objPHPExcel, 'Excel2007');

$filename = __DIR__ . '/ResultadosGenerales.xlsx';
$objWriter->save($filename);

echo json_encode(array("success" => true, "filename" => $filename));
exit;