<style type="text/css">
    img { border: none; }
    input, select, textarea, th, td { font-size: 1em; }

    /* CSS Tree menu styles */
    ol.tree
    {
        padding: 0 0 0 30px;
        width: 100%;
    }
    li 
    { 
        position: relative; 
        margin-left: -15px;
        list-style: none;
    }
    li.file
    {
        margin-left: -1px !important;
    }
    li.file a
    {
        background: url(view/librerias/dist/img/document.png) 0 0 no-repeat;
        color: #fff;
        padding-left: 21px;
        text-decoration: none;
        display: block;
    }
    li.file a[href *= '.pdf']	{ background: url(view/librerias/dist/img/document.png) 0 0 no-repeat; }
    li.file a[href *= '.html']	{ background: url(view/librerias/dist/img/document.png) 0 0 no-repeat; }
    li.file a[href $= '.css']	{ background: url(view/librerias/dist/img/document.png) 0 0 no-repeat; }
    li.file a[href $= '.js']    { background: url(view/librerias/dist/img/document.png) 0 0 no-repeat; }
    li input
    {
        position: absolute;
        left: 0;
        margin-left: 0;
        opacity: 0;
        z-index: 2;
        cursor: pointer;
        height: 1em;
        width: 1em;
        top: 0;
    }
    li input + ol
    {
        background: url(view/librerias/dist/img/toggle-small-expand.png) 40px 3px no-repeat;
        margin: -1.5em 0 0 -44px; /* 15px */
        height: 1.5em;
    }
    li input + ol > li { display: none; margin-left: -14px !important; padding-left: 1px; }
    li label
    {
        background: url(view/librerias/dist/img/folder-horizontal.png) 15px 1px no-repeat;
        cursor: pointer;
        display: block;
        padding-left: 37px;
    }
    li label{
        margin-bottom: 0px;
    }

    li input:checked + ol
    {
        background: url(view/librerias/dist/img/toggle-small.png) 40px -1px no-repeat;
        margin: -1.25em 0 0 -44px; /* 20px */
        padding: 1.563em 0 0 80px;
        height: auto;
    }
    li input:checked + ol > li { display: block; margin: 0 0 0.125em;  /* 2px */}
    li input:checked + ol > li:last-child { margin: 0 0 0.063em; /* 1px */ }
    li label a{
        text-decoration: none;
        color: #3f3f3f;
    }
    li label a:hover{
        color: #5e5d5d;
    }
</style>
<!-- Content Header (Page header) -->
<section class="content-header">
    <h1>
        Seleccionar al Evaluador
        <small></small>
    </h1>
    <ol class="breadcrumb">
        <li><a href="#"><i class="fa fa-dashboard"></i> Inicio</a></li>
        <li class="active">Paso 1 de 3</li>
    </ol>
</section>
<!-- Main content -->
<section class="content">
    <div class="row">
        <div class="col-md-12" id="resultadoPasajero">

        </div>
        <!-- left column -->        
        <div class="col-md-6">
            <div class="box box-primary">
                <div class="box-header"><h4>Estructura de Organigrama</h4></div>
                <div class="box-body" id="arbol_contenido">
                    <?php 
                    $ex = array();
                    foreach ($organigrama as $arb){
                        $ex[] = array('id' => $arb->__GET('Organigrama_Id'),
                                      'codigo' => "",
                                      'nombre' => $arb->__GET('sOrgDescripcion'),
                                      'parentId' => $arb->__GET('nOrgPadre'));
                    }
                    ?>
                    <ol class="tree">
                        <?php
                        $arbol_lista = "";
                        for($j=0;$j<count($ex);$j++){
                            if($ex[$j]['parentId'] == 0){
                                $arbol_lista .= '<li>
                                                    <label>'.$ex[$j]['codigo'].' '.$ex[$j]['nombre'].'</label>
                                                    <input type="checkbox" checked id="folder1" />'
                                                    .Arboles($ex,$ex[$j]['id']).'
                                                </li>';
                            }  
                        }
                        echo $arbol_lista;
                        ?>
                    </ol>
                </div>
            </div>
        </div>
        <div class="col-md-6">
            <div class="box box-primary">
                    <div class="box-header"><h4>Evaluador</h4></div>
                    <div class="box-body">
                            <div id="resultado"></div>
                            <div class="row" id="Frm_Organigrama">
                                <?php 
                                require_once 'view/webforms/wfaevaluaciondet1aAll.php';
                                ?>


                            </div>
                            <!--Hidden para la evaluacion_Id de la cabecera-->
                            <input type="text" name="hdnevaluacion_Id" id="hdnevaluacion_Id" value="<?php echo  isset($evaluacion_Id) ? $evaluacion_Id : '0'; ?>">
                            <div>
                                <button type="button" class="btn btn-defaut btn-flat" data-toggle="modal" data-target="#mAgregarPadrehijo" onclick="abrirModalPadrehijo();"><i class="fa fa-plus"></i></button>
                            </div>

                               <table id="tblPadrehijo" class="table table-bordered table-striped text-center">
                                    <thead>
                                        <tr>
                                            <th>Categoría</th>                             
                                            <th>Cuestionario</th>
                                            <th>Operaciones</th>
                                        </tr>
                                    </thead>
                                    <tbody id="detPadrehijo">
                                        <tr>
                                            <td colspan="3">No hay datos</td>
                                        </tr>  
                                    </tbody>
                                    
                                </table> 
                    </div>
                    <div class="box-footer">                
                        <!-- <button class="btn btn-primary btn-flat" onclick="javascript: form.action='javascript:GuardarFamilia();'">Guardar informacion</button>
                        <button class="btn btn-danger btn-flat"  onclick="javascript: form.action='javascript:LimpiarFrm();';">Cancelar</button> -->
                        <button class="btn btn-danger btn-flat" data-toggle="modal" data-target="#mConfirmarPadrehijo" >Guardar</button>
                        <a class="btn btn-primary btn-flat" onclick="FrmGuardarProducto();">Cancelar</a>

                    </div>  
            </div>
        </div>
    </div>
</section>

<!-- Modal -->
<div id="mAgregarPadrehijo" class="modal fade" role="dialog">
  <div class="modal-dialog">

    <!-- Modal content-->
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal">&times;</button>
        <h4 class="modal-title">Agregar Datos</h4>
      </div>
      <div class="modal-body">
            <div class="row">
                <div class="col-md-12">
                <div id="modalAlert"></div>
                <div class="form-group">
                    <label for="tipo">Categoría</label>
                    <select id="cmbCategoria" name="cmbCategoria" class="form-control">
                        
                    </select>
                    <label for="tipo">Cuestionario</label>
                    <select id="cmbCuestionario" name="cmbCuestionario" class="form-control">
                        
                    </select>
                </div>
            </div>
        </div>
      </div>
      <div class="modal-footer">
        <button onclick="agregarPadrehijo();" type="button" class="btn btn-primary btn-flat">Agregar</button>
        <button type="button" class="btn btn-default btn-flat" data-dismiss="modal">Cancelar</button>
      </div>
    </div>

  </div>
</div>

<!-- Modal Confirmación de -->
<div id="mConfirmarPadrehijo" class="modal fade" role="dialog">
  <div class="modal-dialog">

    <!-- Modal content-->
    <div class="modal-content">
      <div class="modal-header">
        <button type="button" class="close" data-dismiss="modal">&times;</button>
        <h4 class="modal-title">Confirmación</h4>
      </div>
      <div class="modal-body">
            <div class="row">
                <div class="col-md-12">
                    <center><label><h3>¿ESTÁ SEGURO QUE DESEA GENERAR LAS ASIGNACIONES?</h3><h5>Los cambios se realizarán directamente en la base de datos.</h5></label></center>
                </div>
            </div>
      </div>
      <div class="modal-footer">
        <button onclick="FrmGuardarDetalleEvaluacionPadrehijo();" class="btn btn-primary btn-flat">SI</button>
        <button class="btn btn-default btn-flat" data-dismiss="modal">NO</button>
      </div>
    </div>

  </div>
</div>

<script type="text/javascript" src="view/librerias/dist/js/funcionesEvaluacion.js"></script>

<?php 
    
    function Arboles($tree, $padre){
            $cont = 0;
            $list = "<ol>";
            for($i=0;$i<count($tree);$i++){
                if($tree[$i]['parentId'] == $padre){
                    $list .= '<li>
                                <label><a onclick="FrmEditarOrganigramaAll(\''.$tree[$i]['id'].'\');">'.$tree[$i]['codigo'].' '. $tree[$i]['nombre'] .'</a></label>
                                <input type="checkbox" checked id="'.$tree[$i]['nombre'].'" />'
                                .Arboles($tree, $tree[$i]['id']).' 
                              </li>';
                    $cont++;
                }
            }    
            $list .= "</ol>";
            if($cont == 0){
                $list = "";
            }
            return $list;
        }

        function FrmEditarOrganigramaAlla(){
            $organigrama = $this->organigrama_model->Listar();
            $datos = $this->organigrama_model->Buscar($_POST['Organigrama_Id']);

            //variable de session
            foreach ($datos as $r){                
                require 'view/webforms/wfaevaluaciondet1aAll.php';
            }
        }

 ?>